<html>
<head>
<title>Time and time server Setting</title>
<meta HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=/*[ID_CHARSET]*/">
<meta HTTP-EQUIV="Pragma" CONTENT="no-cache">
<meta HTTP-EQUIV="Cache-Control" CONTENT="no-cache, must-revalidate">
<META HTTP-EQUIV="Expires" CONTENT="Tue, 29 Aug 2000 08:16:16 GMT">
<script src="./j04_gfunc_def.js" type="text/javascript"></script>
<script language="JavaScript"> <!--
var	varLanguageType ="" + "/*[Language_type]*/";
var errMsg = new Array
(
	"/*[ID_ERROR0]*/", //"Unknown error!",
	"/*[ID_ERROR1]*/", //"Success!",
	"/*[ID_ERROR2]*/", //"Failure, incorrect time setting!",
	"/*[ID_ERROR3]*/", //"Failure, no required authority !",
	"/*[ID_ERROR4]*/", //"Failure, incomplete information!",
	"/*[ID_ERROR5]*/"//"Failure, ACU is hardware protected"  
);
if(GetCookie("acuIP") == null || GetCookie("acuIP") != getIPFromLocation(window.location))
{
	DeleteCookieT("acuIP");
	window.open("login.htm","_top" );
}

var timeTime="/*[_submitted_time]*/";
var webTime = new Date().getTime()/1000;

function setNewTime( t ) {
	with( document.time ) {
		_current_date.value=getCurDate(t);
		_current_time.value=getCurTime(t);
	}
}

function initForm()
{
	var fm = document.time;
	
	var ts1 = "/*[_time_server1]*/";
	var ts2 = "/*[_time_server2]*/";
	var ts3 = "/*[_time_interval]*/";
	var ts4 = "/*[_time_zone_new]*/";
	fm._time_server1.value = stringIP(ts1);
	fm._time_server2.value = stringIP(ts2);
	fm._interval_adjust.value = atoi(ts3);
	
	setTimeOption( ((ts1=="0" && ts2=="0") ? 1 : 0), false );
	
	fm.a_time_zone.value = MakeTimeZoneInfo(parseInt(ts4));//MakeTimeZoneInfo("/*[_time_zone]*/");
	//MakeTimeZoneInfo( new Date().getTimezoneOffset()*60 );
	setNewTime( timeTime );

	startTimer();

	// CAN NOT MODIFY THE FOLLOWING LINES!!!
	var retCode = ""+ "/*[CONTROL_RESULT]*/";
	if( retCode != "/*[CONTROL_RESULT]*/" ) 
	{
		var ec = parseInt( retCode );
		if( isNaN(ec) || (ec >= errMsg.length) )
			ec = 0;
		if(ec != 1)
		{
			if(ec == 4)		//no required authority
			{
				window.alert( " " + errMsg[ec] );
				fm._modify_configure_detail.value = 6;
				fm.sessionId.value = GetCookie("session_ID");
				fm.language_type.value = (varLanguageType == "0" ) ? 0 : 1;
				fm.submit();
			}
			else if(ec == 5)//protected
			{
				var name = getElement("_time_modify");
				if(name != null)
				{
					name.disabled = true;
				}
				
				 
			}
			else
			{
				window.alert( " " + errMsg[ec] );
			}
		}
	}
	else
	{
		fm._modify_configure_detail.value = 6;
		fm.sessionId.value = GetCookie("session_ID");
		fm.language_type.value = (varLanguageType == "0" ) ? 0 : 1;
		fm.submit();
 	}
}

function stringIP( ip ) // convert long ip to string as 'nnn.nnn.nnn.nnn' 
{
	if( isNaN(ip) )
		ip = atoi(ip);
	var strIP="" + ((ip)&0xff) + "." + ((ip>>8)&0xff) + "." + ((ip>>16)&255) + "." + ((ip>>24)&255);
	return strIP;
}

function atoi( str )
{
	if( !isNumeric(str) )
		return 0;

	var s1 = "", i, c;

	// skip 0 before a decimal string  
	for( i = 0; i < str.length; i ++ ) {
		c = "" + str.charAt(i);
		if( c != "0" )
			break;
	}

	if( i == str.length )
		return 0;
	for( ; i < str.length; i ++ )
		s1 = s1 + str.charAt(i);

	return parseInt( s1 );
}
function getLocalZone() {
	document.time.a_time_zone.value = MakeTimeZoneInfo( new Date().getTimezoneOffset()*60 );
}

function checkTimeForm() {
	var strVal;
	var fm = document.time;
	if(GetCookie("nAuthority") < 3)
	{
		window.alert(errMsg[4]);
		return false;
	}
	var tz = ParseTimeZoneInfo( fm.a_time_zone.value );
	if( tz == -1 ) {
		
		return false;
	}
	fm._time_zone.value = tz;
	
	if( fm._use_time_server[0].checked) {
		strVal = "" + fm._time_server1.value;
		if( !validateIP(strVal) ) {
			fm._time_server1.value = strVal;
			window.alert( "/*[ID_TIPS0]*/");//Incorrect IP address of primary server.\n\nCorrect format should be 'nnn.nnn.nnn.nnn', e., 129.9.1.10. 0.0.0.0 means no time server
			return false;
		}

		strVal = "" + fm._time_server2.value;
		//alert(fm._time_server2.value);
		if( !validateIP(strVal) ) {
			window.alert( "/*[ID_TIPS1]*/");//Incorrect IP address of secondary server.\n\nCorrect format should be 'nnn.nnn.nnn.nnn', e.g., 129.9.1.10. 0.0.0.0 means no time server
			return false;
		}
		
		strVal = "" + fm._interval_adjust.value;
		if(atoi(strVal) <= 0)
		{
			window.alert("/*[ID_TIPS2]*/");//Incorrect time interval.\n\nTime interval should be positive integer!
			
			return false;
		}
		
		
		
		fm._modify_configure_detail.value = 8;
		fm.sessionId.value = GetCookie("session_ID");
		fm.language_type.value = (varLanguageType == "0" ) ? 0 : 1;
		//fm._time.value = "/*[ID_TIPS3]*/";
		//fm.submit();
	} 
	else 
	{
		if( !isDate(fm._current_date) ) 
		{
			window.alert( "/*[ID_TIPS4]*/");//Incorrect date setting.\n\nCorrect format should be 'yyyy/mm/dd', e.g., 2000/09/08
			return false;
		}

		if( !isTime(fm._current_time) ) 
		{
			window.alert( "/*[ID_TIPS5]*/");//Incorrect time setting. \n\nCorrect format should be 'hh:mm:ss', e.g., 8:23:08
			return false;
		}

		//if(fm._time_server1.value !="0.0.0.0" || fm._time_server2.value !="0.0.0.0")
		//{
		//	window.alert("/*[ID_TIPS7]*/");//已经设置校时服务器, 此时间将会在校时时间到时自动进行校时！
		//	return false;
		//}
		
		var strDate = fm._current_date.value;
		var strTime = fm._current_time.value;

		var sIn  = getSeconds( strDate, strTime);
		var sMin = 0;	// 1999/01/01 0:0:0
		var sMax = 2145916800;	// 2038/01/01 0:0:0
		if( (sMin > sIn) || (sIn >= sMax) ) 
		{
			window.alert( "/*[ID_TIPS6]*/" );//Date must be set between '1999/01/01 00:00:00' and '2106/02/06 00:00:00'.
			return false;
		}

		fm._submitted_time.value = sIn ;//+ tz;
		fm._modify_configure_detail.value = 7;
		fm.sessionId.value = GetCookie("session_ID");
		fm.language_type.value = (varLanguageType == "0" ) ? 0 : 1;
		//fm.submit();
	}

	//fm._time.disabled = true;

	return true;
}

var bPausedTimer = false;
var timerID = null;
function timer() {
	if( !bPausedTimer ) {
		//var now = timeTime + (new Date().getTime()/1000 - webTime);
		
		//setNewTime( now );
	}
}

var bChanged = false;
function startTimer() {
	stopTimer();

	if( bChanged )
		return;

	if( bPausedTimer )
		bPausedTimer = false;
	else with( document.time ) {
		timeTime = getSeconds( _current_date.value, 
			_current_time.value);
	}

	timerID = window.setInterval("timer();", 1000 );
}

function stopTimer() {
	if( timerID != null ) {
		window.clearInterval( timerID );
		timerID = null;
	}
}

var bToLoc = false;
function initWithLocalTime() {
	stopTimer();
    bToLoc = true;

	with( document.time ) {
		timeTime = webTime = new Date().getTime()/1000;
		setNewTime(timeTime);
	}
	
	setTimeOption(1, false);
	bChanged = false;
	
	startTimer();
}

function updateView() {
	var d = top.ups_data;
	if( bToLoc || bChanged || (d == null) || (d.cardTime == null) )
		return;

	timeTime = d.cardTime;
	webTime = new Date().getTime()/1000;
}

function setTimeOption( setTo, bPause ) {
	document.time._use_time_server[setTo].checked = true;
	
	bPausedTimer = bPause;
}

function MakeTimeZoneInfo( nTimeZone )//unit is seconds
{
	var nTZ, buf;

	if( isNaN(nTimeZone) )
		nTimeZone = -28800;//china

	buf = "GMT";
	buf += "" + ((nTimeZone > 0) ? '-' : '+');
	nTZ = (nTimeZone > 0) ? nTimeZone : -nTimeZone;

	var hr = Math.floor(nTZ/3600);
	var mn = Math.floor((nTZ%3600)/60);

	buf += "" + ((hr>=10) ? hr : "0"+hr) + ":" + ((mn>=10) ? mn : "0"+mn);

	return buf;
}

function ParseTimeZoneInfo( zi )
{
	var nSign, nHr = 0, nMin = 0;
	var i;

	/* GMT+hh:mm */
	if( (zi == null) || (zi.length == 0) )
		return -1;

	if( (zi.charAt(0) != "G") && (zi.charAt(0) != "g") &&
		(zi.charAt(1) != 'M') && (zi.charAt(1) != 'm') &&
		(zi.charAt(2) != 'T') && (zi.charAt(2) != 't') )
			return -1;

	if( zi.length == 3 )
		return 0;	 /* GMT standard time */
	
	/* sign */
	if( zi.charAt(3) == '+' )
		nSign = -1;
	else if( zi.charAt(3) == '-' )
		nSign = +1;
	else
		return -1;

	/* hrs */
	i = 4;
	var c = zi.charAt(i);
	if( ( c >= "0" ) && (c <= "9" ) )	 {
		nHr = parseInt(c);
		i ++; 
	}
	else
		return -1;

	c = zi.charAt(i);
	if( ( c >= "0" ) && (c <= "9" ) )	 {
		nHr = nHr*10 + parseInt(c);
		i ++;
	}

	if( nHr >= 24 )
		return -1;

	if( zi.length == i ) /* no min. */
		return nSign*nHr*3600;

	if( zi.charAt(i) != ':' )
		return -1;

	/* min. */
	i ++;
	c = zi.charAt(i);
	if( ( c >= "0" ) && (c <= "9" ) )	 {
		nMin = parseInt(c);
		i ++; 
	}
	else
		return -1;

	c = zi.charAt(i);
	if( ( c >= "0" ) && (c <= "9" ) )	 {
		nMin = nMin*10 + parseInt(c);
		i ++;
	}

	if( nMin >= 60 )
		return -1;

	return nSign*(nHr*3600 + nMin*60);
}




//function fitForm() {
//	var td = getElement("formBody");
//	if( td )
//		td.style.height  = document.body.offsetHeight*0.85;
//}

//--></script>
<style type="text/css">
body { font-family:Arial; background:#fff; font-size:12px;scrollbar-face-color: #b4cee9; scrollbar-shadow-color: #b4cee9;scrollbar-highlight-color:#b4cee9; scrollbar-3dlight-color: #b4cee9; scrollbar-darkshadow-color: #b4cee9; scrollbar-track-color:#f1f1f1; scrollbar-arrow-color: #fff;}
.setTable { margin-top:25px; border-left:#7f9db9 solid 1px; border-top:#7f9db9 solid 1px; background:#fff; }
.setTable th { height:30px; line-height:30px; color:#fff; background:#3d85c4; text-align:left; font-size:14px; padding-left:10px; }
.setTable td { border-right:#7f9db9 solid 1px; border-bottom:#7f9db9 solid 1px; font-family:Arial; font-weight:bold; padding:0 10px;font-size:12px; }
.setTable td strong { display:inline-block; width:80px; font-size:12px;}
.setTable td select,.setTable td input { font-family:Arial; font-size:12px; }
</style>
</head>
<body onLoad=" initForm();" onUnload="stopTimer();">
<form method="post" action="/cgi-bin/web_cgi_setting.cgi" name="time" onSubmit=" return checkTimeForm();" ID="Form1">
  <input type="hidden" name="_modify_configure" value="4" ID="Hidden1">
  <input type="hidden" name="_modify_configure_detail" value="0" ID="Hidden2">
  <input type="hidden" name="language_type" value="0" ID="Hidden3">
  <input type="hidden" name="_time_zone" value="-28800" ID="Hidden4">
  <input type="hidden" name="_submitted_time" ID="Hidden5">
  <input type="hidden" name="sessionId" ID="Hidden6">
  <table width="80%" border="0" align="center" cellpadding="0" cellspacing="0" class="setTable">
    <tr>
      <th>/*[ID_TIME_HEAD]*/</th>
    </tr>
    <tr>
      <td height="35">/*[ID_ZONE]*/:
        <input type="text" name="a_time_zone" value="GMT+08:00" maxlength="10" size="12" ID="Text1">
      <input type="button" name="Button" value="/*[ID_GET_ZONE]*/" onClick="getLocalZone();" ID="Button1"></td>
    </tr>
  </table>
  <table width="80%" border="0" align="center" cellpadding="0" cellspacing="0" class="setTable" style="margin:0;">
    <tr>
      <td width="7%" height="30"><input type="radio" name="_use_time_server" value="1" checked ID="Radio1"></td>
      <td width="93%" height="30">/*[ID_SELECT1]*/</td>
    </tr>
    <tr>
      <td rowspan="3">&nbsp;</td>
      <td height="30">/*[ID_PRIMARY_SERVER]*/:
      <input type="text" name="_time_server1" size="16" maxlength="15" onFocus="setTimeOption(0,false);" ID="Text2"></td>
    </tr>
    <tr>
      <td height="30">/*[ID_SECONDARY_SERVER]*/:
      <input type="text" name="_time_server2" size="16" maxlength="15" onFocus="setTimeOption(0,false);" ID="Text3"></td>
    </tr>
    <tr>
      <td height="30">/*[ID_TIMER_INTERVAL]*/:
        <input type="text" name="_interval_adjust" size="9" maxlength="8" onFocus="setTimeOption(0,false);" ID="Text4">
        /*[ID_MINUTES]*/ </td>
    </tr>
    <tr>
      <td height="30"><input type="radio" name="_use_time_server" value="2" ID="Radio2"></td>
      <td height="30">/*[ID_SPECIFY_TIME]*/
      <input type="button" name="get_cur_time" value="/*[ID_GET_TIME]*/" onClick="initWithLocalTime();" ID="Button2"></td>
    </tr>
    <tr>
      <td rowspan="2">&nbsp;</td>
      <td height="30">/*[ID_DATE]*/:
      <input type="text" name="_current_date" maxlength="10" size="11" onFocus="setTimeOption(1,true);" onBlur="startTimer();" onChange="bChanged=true;" ID="Text5"></td>
    </tr>
    <tr>
      <td height="30">/*[ID_TIME]*/:
      <input type="text" name="_current_time" size="9" maxlength="8" onFocus="setTimeOption(1,true);" onBlur="startTimer();" onChange="bChanged=true;" ID="Text6"></td>
    </tr>
    <tr>
      <td height="30" colspan="2" align="center"><INPUT type="submit" value="/*[ID_SUBMIT]*/" name="_time_modify" id="_time_modify"></td>
    </tr>
  </table>
    <script type="text/javascript">
 setGradient(document.body, '#fefefe','#dfe4ea',0); 
</script>
</form>
</body>
</html>
